Subject: Re: bug#21605: 24.3; Eshell not using stderr

From: Jim Porter <[email-masked]>
Date: Thu, 12 May 2022 19:14:46 -0700

On 5/12/2022 5:26 AM, Lars Ingebrigtsen wrote:
> This seems to be the case in Emacs 29, too, but I'm not sure whether
> this is by design or not.  I've added Jim to the CCs; perhaps he has
> some input here.

I think this is just a missing feature, partly due to the fact that the 
redirection operators don't let you redirect a specific fd. That's in 
the "Bugs and Ideas" section of the Eshell manual though:

   Support ‘2>&1’ and ‘>&’ and ‘2>’ and ‘|&’

     The syntax table for parsing these should be customizable, such that
     the user could change it to use rc syntax: ‘>[2=1]’.

Doing that is probably the hardest part. The other bit that would need 
to be fixed is (I think) to modify `eshell-gather-process-output' to use 
`make-process' instead of `start-file-process', and then give it a 
:stderr argument so that Emacs doesn't write both stdout and stderr to a 
single temp buffer.

I agree that this would definitely be nice to have though.